import { PolymerElement, html } from '@polymer/polymer/polymer-element.js';

class HomePage extends PolymerElement {
  static get template() {
    return html`


        <style>
            body {
                margin: 0;
                font-family: sans-serif;
                line-height: 1.5;
                min-height: 100vh;
                background: #fff;
                overflow: scroll;
            }

            section {
                padding: 80px 48px;
            }

            section.small {
                padding: 24px 48px;
                display: block;
            }

            section>* {
                max-width: 1024px;
                margin: 0 auto
            }

            @media (max-width: 1024px) {
                section>* {
                    max-width: 900px;
                    margin: 0 auto
                }
            }

            a {
                font-size: 14px;
                text-decoration: none;
                color: #1724BA;
            }

            a:hover {
                text-decoration: underline;
            }

            .link {
                padding-bottom: 6px;
                padding-top: 6px;
            }

            .logo {
                height: 32px;
                padding: 14px;
            }

            .header {
                width: 100%;
                height: 60px;
                box-shadow: 1px 2px 2px rgba(0, 0, 0, 0.2);
                background: #1724BA;
                color: #fff;
                font-size: 39px;
            }

            .main-text {
                font-size: 36px;
                line-height: 1.2;
            }

            .sub-text {
                margin-bottom: 24px;
                font-size: 16px;
                line-height: 24px;
            }

            .container {
                padding-left: 100px;
                padding-right: 100px;
                width: 80%;
            }

            .features-heading {
                font-size: 24px!important;
            }

            .feature {
                padding: 30px;
                margin-right: 16px;
                margin-bottom: 16px;
                display: block;
                box-sizing: border-box;
                background: #F5F5F5;
                text-decoration: none;
                color: #2D2D2D;
                width: calc(50% - 20px);
            }

            .feature-content {
                font-size: 16px!important;
            }

            .coming-soon {
                font-size: 14px!important;
                color: #666;
            }

            .code-style {
                background-color: #eff0f1
            }
        </style>



    <section class="small">
        <div class="main-text">
            <div>Congratulations on getting started !</div>
            <div class="sub-text">
                <p> Open Enterprise Cloud is an open source framework for development of modern cloud native enterprise applications</p>
            </div>
        </div>

    </section>
    <section class="small">
        <div class="container">
            <div class="feature-content">You'll probably also want to learn about our key features : </div>
            <div class="flex layout horizontal style-scope" style="flex-direction: row;display:flex;flex-wrap:wrap;margin-top:24px;">

                <div class="feature">
                    <div class="features-heading">
                        Service Modeling
                    </div>
                    <p class="feature-content">oeCloud.io is model driven framework.Model represents Business Entity. This also makes application micro
                        service enabled.Follow below links to understand some of these features : </p>

                    <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/baseentity">What is a model</a></div>
                    <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/userlogin">Authorization</a></div>
                    <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/createmodel">Creating a Model</a></div>
                    <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/manageamodel">Manage a model</a></div>
                    <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/modelrelations">Create Relations among models</a></div>

                </div>
                <div class="feature">
                    <div class="features-heading">
                        Business Logic
                    </div>
                    <p class="feature-content">With oeCloud.io, various aspects of business logic can be made declarative. You can design model with
                        inbuilt validation support, you can create business rules and you can create workflow around model
                        - all this at runtime</p>
                    <div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/validations">Validations</a></div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/relationalvalidation">Relational Validations</a></div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/conditionalvalidation">Conditional Validations</a></div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/customvalidation">Custom Validations</a></div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/businessruleengine">Business Rule Engine</a></div>
                    </div>
                </div>
                <div class="feature">
                    <div class="features-heading">
                        Application Pattern
                    </div>
                    <p class="feature-content">oeCloud.io employs various Enterprise Application patterns to guarantee performance and data integrity
                        in scalable clustered environment</p>
                    <div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/modelhistory">Model History Functionality</a></div>
                    </div>
                </div>
                <div class="feature">
                    <div class="features-heading">
                        Event Management
                    </div>
                    <p class="feature-content">oeCloud.io components communicate with each other using events. Event reliability is managed by oeCloud.io
                        framework
                    </p>
                    <div>
                        <span class="coming-soon">*GUIDES COMING SOON</span>
                    </div>
                </div>
                <div class="feature">
                    <div class="features-heading">
                        Data Sources
                    </div>
                    <p class="feature-content">Application doesn't need to worry about underlying data source. oeCloud.io has ability to connect to
                        various data sources, SQL data source or noSQL Datasource</p>
                    <div>
                        <span class="coming-soon">*GUIDES COMING SOON</span>
                    </div>
                </div>
                <div class="feature">
                    <div class="features-heading">
                        Contextual Behavior
                    </div>
                    <p class="feature-content">oeCloud.io framework based application can be configured to behave differently based on context. Context
                        can be tenant, user, region, device and so on.. </p>
                    <div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/datapersonalization">Data Personalisation</a></div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/servicePersonalization">Service Personalisation</a></div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/modelpersonalization">Model Personalisation</a></div>

                    </div>
                </div>
                <div class="feature">
                    <div class="features-heading">
                        Supportability
                    </div>
                    <p class="feature-content">oeCloud.io offers various supporting features like logging, auditing out of box</p>
                    <div>
                        <div class="link"><a target="_blank" rel="noopener noreferrer" href="https://www.oecloud.io/guide/auditcontrol">Model Auditing Functionality</a></div>
                    </div>
                </div>

            </div>

    </section>

        `;
  }
  static get properties() {
    return {

    };
  }
  connectedCallback() {
    super.connectedCallback();
  }
}
window.customElements.define('home-page', HomePage);
